package com.starcite.marketplace.concurrent;

import java.util.UUID;
import java.util.concurrent.LinkedBlockingQueue;

/**
 * Created by StarCite.
 * User: andy.song
 * Date: Nov 18, 2010
 * Time: 11:27:07 AM
 * To change this template use File | Settings | File Templates.
 */
public class LockFreeBlockingQueueTester {

    LockFreeBlockingQueue<String> queue = new LockFreeBlockingQueue<String>(Integer.MAX_VALUE);

    public class Input extends Thread {
        int i = 0;
        public void run() {
            while (true) {
                try {
                    queue.put(UUID.randomUUID().toString());
                    if(++i == 1000) {
                        break;
                    }
                } catch (InterruptedException e) {
                    e.printStackTrace();
                }
            }
        }
    }

    public class Output extends Thread {
        int i = 1000;
        public void run() {
            while (true) {
                long time = System.nanoTime();
                String value = queue.poll();
                //System.out.println(queue.poll());
                if (value != null) {
                    System.out.println(System.nanoTime() - time + " nSec");
                    if(--i == 0) {
                        break;
                    }
                }
            }
        }
    }


    public static void main(String[] args) {
        LockFreeBlockingQueueTester tester = new LockFreeBlockingQueueTester();
        int n = 16;
        for (int i = 0; i < n; ++i) {
            tester.new Input().start();
        }

        for (int i = 0; i < n; ++i) {
            tester.new Output().start();
        }

    }
}
